Package ch.qos.logback.core.joran.action

# Class Action

java.lang.Object
ch.qos.logback.core.spi.ContextAwareBase
ch.qos.logback.core.joran.action.Action

All Implemented Interfaces:
  `ContextAware`

Direct Known Subclasses:
  `AbstractEventEvaluatorAction`, `AppenderAction`, `AppenderRefAction`, `ConfigurationAction`, `ConfigurationAction`, `ConsolePluginAction`, `ContextNameAction`, `ContextPropertyAction`, `ConversionRuleAction`, `DefinePropertyAction`, `IfAction`, `ImplicitAction`, `IncludeAction`, `InsertFromJNDIAction`, `JMXConfiguratorAction`, `LevelAction`, `LoggerAction`, `LoggerContextListenerAction`, `NewRuleAction`, `NOPAction`, `ParamAction`, `PropertyAction`, `ReceiverAction`, `RootLoggerAction`, `ShutdownHookAction`, `SiftAction`, `SiftAction`, `StatusListenerAction`, `ThenOrElseActionBase`, `TimestampAction`

public abstract class Action extends ContextAwareBase
Most of the work for configuring logback is done by Actions.

Action methods are invoked as the XML file is parsed.

This class is largely inspired from the relevant class in the commons-digester project of the Apache Software Foundation.

Author:
  Craig McClanahan, Christopher Lenz, Ceki Gülcü

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`ACTION_CLASS_ATTRIBUTE`
`static final String`
`CLASS_ATTRIBUTE`
`static final String`
`FILE_ATTRIBUTE`
`static final String`
`KEY_ATTRIBUTE`
`static final String`
`NAME_ATTRIBUTE`
`static final String`
`PATTERN_ATTRIBUTE`
`static final String`
`SCOPE_ATTRIBUTE`
`static final String`
`VALUE_ATTRIBUTE`

### Fields inherited from class ch.qos.logback.core.spi.ContextAwareBase

`context`

## Constructor Summary

Constructors
Constructor
Description
`Action()`

## Method Summary

Modifier and Type
Method
Description
`abstract void`
`begin(InterpretationContext ic, String name, Attributes attributes)`
Called when the parser encounters an element matching a `Pattern`.
`void`
`body(InterpretationContext ic, String body)`
Called to pass the body (as text) contained within an element.
`abstract void`
`end(InterpretationContext ic, String name)`
`protected int`
`getColumnNumber(InterpretationContext ic)`
`protected String`
`getLineColStr(InterpretationContext ic)`
`protected int`
`getLineNumber(InterpretationContext ic)`
`String`
`toString()`

### Methods inherited from class ch.qos.logback.core.spi.ContextAwareBase

`addError, addError, addInfo, addInfo, addStatus, addWarn, addWarn, getContext, getDeclaredOrigin, getStatusManager, setContext`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Field Details

### NAME_ATTRIBUTE

public static final String NAME_ATTRIBUTE

See Also:
  - Constant Field Values

### KEY_ATTRIBUTE

public static final String KEY_ATTRIBUTE

See Also:
  - Constant Field Values

### VALUE_ATTRIBUTE

public static final String VALUE_ATTRIBUTE

See Also:
  - Constant Field Values

### FILE_ATTRIBUTE

public static final String FILE_ATTRIBUTE

See Also:
  - Constant Field Values

### CLASS_ATTRIBUTE

public static final String CLASS_ATTRIBUTE

See Also:
  - Constant Field Values

### PATTERN_ATTRIBUTE

public static final String PATTERN_ATTRIBUTE

See Also:
  - Constant Field Values

### SCOPE_ATTRIBUTE

public static final String SCOPE_ATTRIBUTE

See Also:
  - Constant Field Values

### ACTION_CLASS_ATTRIBUTE

public static final String ACTION_CLASS_ATTRIBUTE

See Also:
  - Constant Field Values

## Constructor Details

### Action

public Action()

## Method Details

### begin

public abstract void begin(InterpretationContext ic, String name, Attributes attributes) throws ActionException
Called when the parser encounters an element matching a `Pattern`.

Throws:
  `ActionException`

### body

public void body(InterpretationContext ic, String body) throws ActionException
Called to pass the body (as text) contained within an element.

Parameters:
  `ic` -
  `body` -
Throws:
  `ActionException`

### end

public abstract void end(InterpretationContext ic, String name) throws ActionException

Throws:
  `ActionException`

### toString

public String toString()

Overrides:
  `toString` in class `Object`

### getColumnNumber

protected int getColumnNumber(InterpretationContext ic)

### getLineNumber

protected int getLineNumber(InterpretationContext ic)

### getLineColStr

protected String getLineColStr(InterpretationContext ic)